package kr.robomation.physical;

/**
 * @author akaii@kw.ac.kr (Kwang-Hyun Park)
 */
public interface Hamster
{
	public static final int CODE = 0x0204;
	public static final String ID = "kr.robomation.physical.hamster";
	
	public static final int LEFT_WHEEL = 0x00400000;
	public static final int RIGHT_WHEEL = 0x00400001;
	public static final int BUZZER = 0x00400002;
	public static final int OUTPUT_A = 0x00400003;
	public static final int OUTPUT_B = 0x00400004;
	public static final int TOPOLOGY = 0x00400005;
	public static final int LEFT_LED = 0x00400006;
	public static final int RIGHT_LED = 0x00400007;
	public static final int NOTE = 0x00400008;
	public static final int LINE_TRACER_MODE = 0x00400009;
	public static final int LINE_TRACER_SPEED = 0x0040000a;
	public static final int IO_MODE_A = 0x0040000b;
	public static final int IO_MODE_B = 0x0040000c;
	public static final int CONFIG_PROXIMITY = 0x0040000d;
	public static final int CONFIG_GRAVITY = 0x0040000e;
	public static final int CONFIG_BAND_WIDTH = 0x0040000f;

	public static final int SIGNAL_STRENGTH = 0x00400010;
	public static final int LEFT_PROXIMITY = 0x00400011;
	public static final int RIGHT_PROXIMITY = 0x00400012;
	public static final int LEFT_FLOOR = 0x00400013;
	public static final int RIGHT_FLOOR = 0x00400014;
	public static final int ACCELERATION = 0x00400015;
	public static final int LIGHT = 0x00400016;
	public static final int TEMPERATURE = 0x00400017;
	public static final int INPUT_A = 0x00400018;
	public static final int INPUT_B = 0x00400019;
	public static final int LINE_TRACER_STATE = 0x0040001a;

	public static final int TOPOLOGY_NONE = 0;
	public static final int TOPOLOGY_DAISY_CHAIN = 1;
	public static final int TOPOLOGY_STAR = 2;
	public static final int TOPOLOGY_EXTENDED_STAR = 3;

	public static final int LED_OFF = 0;
	public static final int LED_BLUE = 1;
	public static final int LED_GREEN = 2;
	public static final int LED_CYAN = 3;
	public static final int LED_RED = 4;
	public static final int LED_MAGENTA = 5;
	public static final int LED_YELLOW = 6;
	public static final int LED_WHITE = 7;

	public static final int LINE_TRACER_MODE_OFF = 0;
	public static final int LINE_TRACER_MODE_BLACK_LEFT_SENSOR = 1;
	public static final int LINE_TRACER_MODE_BLACK_RIGHT_SENSOR = 2;
	public static final int LINE_TRACER_MODE_BLACK_BOTH_SENSORS = 3;
	public static final int LINE_TRACER_MODE_BLACK_TURN_LEFT = 4;
	public static final int LINE_TRACER_MODE_BLACK_TURN_RIGHT = 5;
	public static final int LINE_TRACER_MODE_BLACK_MOVE_FORWARD = 6;
	public static final int LINE_TRACER_MODE_BLACK_UTURN = 7;
	public static final int LINE_TRACER_MODE_WHITE_LEFT_SENSOR = 8;
	public static final int LINE_TRACER_MODE_WHITE_RIGHT_SENSOR = 9;
	public static final int LINE_TRACER_MODE_WHITE_BOTH_SENSORS = 10;
	public static final int LINE_TRACER_MODE_WHITE_TURN_LEFT = 11;
	public static final int LINE_TRACER_MODE_WHITE_TURN_RIGHT = 12;
	public static final int LINE_TRACER_MODE_WHITE_MOVE_FORWARD = 13;
	public static final int LINE_TRACER_MODE_WHITE_UTURN = 14;

	public static final int IO_MODE_ADC = 0;
	public static final int IO_MODE_DI = 1;
	public static final int IO_MODE_SERVO = 8;
	public static final int IO_MODE_PWM = 9;
	public static final int IO_MODE_DO = 10;

	public static final int NOTE_OFF = 0;
	public static final int NOTE_A_0 = 1;
	public static final int NOTE_A_SHARP_0 = 2;
	public static final int NOTE_B_FLAT_0 = 2;
	public static final int NOTE_B_0 = 3;
	public static final int NOTE_C_1 = 4;
	public static final int NOTE_C_SHARP_1 = 5;
	public static final int NOTE_D_FLAT_1 = 5;
	public static final int NOTE_D_1 = 6;
	public static final int NOTE_D_SHARP_1 = 7;
	public static final int NOTE_E_FLAT_1 = 7;
	public static final int NOTE_E_1 = 8;
	public static final int NOTE_F_1 = 9;
	public static final int NOTE_F_SHARP_1 = 10;
	public static final int NOTE_G_FLAT_1 = 10;
	public static final int NOTE_G_1 = 11;
	public static final int NOTE_G_SHARP_1 = 12;
	public static final int NOTE_A_FLAT_1 = 12;
	public static final int NOTE_A_1 = 13;
	public static final int NOTE_A_SHARP_1 = 14;
	public static final int NOTE_B_FLAT_1 = 14;
	public static final int NOTE_B_1 = 15;
	public static final int NOTE_C_2 = 16;
	public static final int NOTE_C_SHARP_2 = 17;
	public static final int NOTE_D_FLAT_2 = 17;
	public static final int NOTE_D_2 = 18;
	public static final int NOTE_D_SHARP_2 = 19;
	public static final int NOTE_E_FLAT_2 = 19;
	public static final int NOTE_E_2 = 20;
	public static final int NOTE_F_2 = 21;
	public static final int NOTE_F_SHARP_2 = 22;
	public static final int NOTE_G_FLAT_2 = 22;
	public static final int NOTE_G_2 = 23;
	public static final int NOTE_G_SHARP_2 = 24;
	public static final int NOTE_A_FLAT_2 = 24;
	public static final int NOTE_A_2 = 25;
	public static final int NOTE_A_SHARP_2 = 26;
	public static final int NOTE_B_FLAT_2 = 26;
	public static final int NOTE_B_2 = 27;
	public static final int NOTE_C_3 = 28;
	public static final int NOTE_C_SHARP_3 = 29;
	public static final int NOTE_D_FLAT_3 = 29;
	public static final int NOTE_D_3 = 30;
	public static final int NOTE_D_SHARP_3 = 31;
	public static final int NOTE_E_FLAT_3 = 31;
	public static final int NOTE_E_3 = 32;
	public static final int NOTE_F_3 = 33;
	public static final int NOTE_F_SHARP_3 = 34;
	public static final int NOTE_G_FLAT_3 = 34;
	public static final int NOTE_G_3 = 35;
	public static final int NOTE_G_SHARP_3 = 36;
	public static final int NOTE_A_FLAT_3 = 36;
	public static final int NOTE_A_3 = 37;
	public static final int NOTE_A_SHARP_3 = 38;
	public static final int NOTE_B_FLAT_3 = 38;
	public static final int NOTE_B_3 = 39;
	public static final int NOTE_C_4 = 40;
	public static final int NOTE_C_SHARP_4 = 41;
	public static final int NOTE_D_FLAT_4 = 41;
	public static final int NOTE_D_4 = 42;
	public static final int NOTE_D_SHARP_4 = 43;
	public static final int NOTE_E_FLAT_4 = 43;
	public static final int NOTE_E_4 = 44;
	public static final int NOTE_F_4 = 45;
	public static final int NOTE_F_SHARP_4 = 46;
	public static final int NOTE_G_FLAT_4 = 46;
	public static final int NOTE_G_4 = 47;
	public static final int NOTE_G_SHARP_4 = 48;
	public static final int NOTE_A_FLAT_4 = 48;
	public static final int NOTE_A_4 = 49;
	public static final int NOTE_A_SHARP_4 = 50;
	public static final int NOTE_B_FLAT_4 = 50;
	public static final int NOTE_B_4 = 51;
	public static final int NOTE_C_5 = 52;
	public static final int NOTE_C_SHARP_5 = 53;
	public static final int NOTE_D_FLAT_5 = 53;
	public static final int NOTE_D_5 = 54;
	public static final int NOTE_D_SHARP_5 = 55;
	public static final int NOTE_E_FLAT_5 = 55;
	public static final int NOTE_E_5 = 56;
	public static final int NOTE_F_5 = 57;
	public static final int NOTE_F_SHARP_5 = 58;
	public static final int NOTE_G_FLAT_5 = 58;
	public static final int NOTE_G_5 = 59;
	public static final int NOTE_G_SHARP_5 = 60;
	public static final int NOTE_A_FLAT_5 = 60;
	public static final int NOTE_A_5 = 61;
	public static final int NOTE_A_SHARP_5 = 62;
	public static final int NOTE_B_FLAT_5 = 62;
	public static final int NOTE_B_5 = 63;
	public static final int NOTE_C_6 = 64;
	public static final int NOTE_C_SHARP_6 = 65;
	public static final int NOTE_D_FLAT_6 = 65;
	public static final int NOTE_D_6 = 66;
	public static final int NOTE_D_SHARP_6 = 67;
	public static final int NOTE_E_FLAT_6 = 67;
	public static final int NOTE_E_6 = 68;
	public static final int NOTE_F_6 = 69;
	public static final int NOTE_F_SHARP_6 = 70;
	public static final int NOTE_G_FLAT_6 = 70;
	public static final int NOTE_G_6 = 71;
	public static final int NOTE_G_SHARP_6 = 72;
	public static final int NOTE_A_FLAT_6 = 72;
	public static final int NOTE_A_6 = 73;
	public static final int NOTE_A_SHARP_6 = 74;
	public static final int NOTE_B_FLAT_6 = 74;
	public static final int NOTE_B_6 = 75;
	public static final int NOTE_C_7 = 76;
	public static final int NOTE_C_SHARP_7 = 77;
	public static final int NOTE_D_FLAT_7 = 77;
	public static final int NOTE_D_7 = 78;
	public static final int NOTE_D_SHARP_7 = 79;
	public static final int NOTE_E_FLAT_7 = 79;
	public static final int NOTE_E_7 = 80;
	public static final int NOTE_F_7 = 81;
	public static final int NOTE_F_SHARP_7 = 82;
	public static final int NOTE_G_FLAT_7 = 82;
	public static final int NOTE_G_7 = 83;
	public static final int NOTE_G_SHARP_7 = 84;
	public static final int NOTE_A_FLAT_7 = 84;
	public static final int NOTE_A_7 = 85;
	public static final int NOTE_A_SHARP_7 = 86;
	public static final int NOTE_B_FLAT_7 = 86;
	public static final int NOTE_B_7 = 87;
	public static final int NOTE_C_8 = 88;
}
